﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace ViewBuilder
{
    public partial class CreateTableForm : Form
    {//begin class

        //string to hold the htmlTable code
        private String htmlTable;

        public String HtmlTable
        {
            get { return htmlTable; }
            set { htmlTable = value; }
        }


        public CreateTableForm()
        {//begin contstructor
            InitializeComponent();
        }//end constructor

        private void okButton_Click(object sender, EventArgs e)
        {//begin method

            //create local String html to hold the html code
            StringBuilder html = new StringBuilder();

            //append the opening table tag
            html.Append("<table>");

            //append the opening table row tag
            html.Append("<tr>");

            for (int rows = 0; rows < tableDataGridView.Rows.Count; rows++)
            {//begin outer for loop

                for (int col = 0; col < tableDataGridView.Rows[rows].Cells.Count; col++)
                {//being inner for loop

                    //append the table data
                    html.Append("<td>");
                    html.Append(tableDataGridView.Rows[rows].Cells[col].Value);
                    html.Append("</td>");


                }//end inner for loop

                //append the closing table row tag
                html.Append("</tr>");

            }//end outer for loop
           
            //append the closing table tag
            html.Append("</table>");


                       
            //assign the html code to the local variable html
            //html = "<table><tr><td>first coloumn</td><td>second column</td></tr></table>";


            //set the html to insert into the web page
            Clipboard.SetText(html.ToString(), TextDataFormat.Html);


            //set the html table code
            this.HtmlTable = html.ToString();

            //if the doc object is not empty so an exception not thrown
            if (ViewBuilderMainForm.Doc != null)
            {//begin if then

                //paste the html into the webpage at the cursor position
                ViewBuilderMainForm.Doc.execCommand("Paste");

            }//end if then
            else
            {//begin if then else

            //let the user know that a file must be open before you can insert a table
                MessageBox.Show("A file must be open in order to add a table","Error");

            }//end if then else

            //close the form
            this.Close();

        }//end method

        private void cancelButton_Click(object sender, EventArgs e)
        {//begin method


            //close the form
            this.Close();

        }//end method

        private void CreateTableForm_Load(object sender, EventArgs e)
        {//begin method

            
            //set the control to false on startup until its column and row properties are set
            tableDataGridView.Visible = false;

            //make the row headers not visible
            tableDataGridView.RowHeadersVisible = false;


        }//end method

        private void buildTableButton_Click(object sender, EventArgs e)
        {//begin method

            
            try
            {//begin try block

                //create the number of rows converting the string input to an integer
                tableDataGridView.RowCount = Int32.Parse(numOfRowsTextBox.Text);


                //create the number of columns converting the string input to an integer
                tableDataGridView.ColumnCount = Int32.Parse(numOfColsTextBox.Text);

                //show the control after its column and row count properties are set
                tableDataGridView.Visible = true;

            }
            catch (FormatException ex)
            {//begin catch


            //let the user know the error
                MessageBox.Show("You must enter a whole number. Text,decimal numbers, or special symbols are not allowed","Error");

            }//end catch
            catch (OverflowException ex)
            {//begin catch


            //let the user know the error
             MessageBox.Show("You have entered too large of a number value. Please try a smaller number value","Error");

            }//end catch

        }

        private void addColumnButton_Click(object sender, EventArgs e)
        {//begin method

            //get the column count of the tableDataGridView and store it
            int getColCount = tableDataGridView.ColumnCount;

            //add one to the ColumnCount property of the tableDataGridView
            tableDataGridView.ColumnCount = tableDataGridView.ColumnCount + 1;
            


        }//end method
    }//end class
}
