﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace ViewBuilder
{//begin name space
    class FileOperations
    {//begin class

        //create an instance of the openFileDialog class
        OpenFileDialog openFileDialog = new OpenFileDialog();

        //create string to store file code in string form
        private String fileContents;

        public String FileContents
        {
            get { return fileContents; }
            set { fileContents = value; }
        }

        //create a StringBuilder object to hold the source of the file page
        StringBuilder source = new StringBuilder();

        

        //end property method section

        /*
         * This method makes a rich text box selection bold if it is not already bold
         * 
         * 
         */
        public void setBold(RichTextBox richTextBox,TextBox htmlSource)
        {//begin method

            //if the selection is bold
            if (richTextBox.SelectionFont.Bold)
            {//begin if then else

                //remove bold formatting from the selected text
                richTextBox.SelectionFont = new Font(richTextBox.SelectionFont, richTextBox.SelectionFont.Style ^ FontStyle.Bold);


                //debug only
                //Console.WriteLine("rich text selection:" + richTextBox.SelectionStart + "," + (richTextBox.SelectionLength + richTextBox.SelectionStart));


            }

            else
            {
                //make the selection bold using a new Font object
                richTextBox.SelectionFont = new Font(richTextBox.SelectionFont, richTextBox.SelectionFont.Style | FontStyle.Bold);
                
                //make the selection bold using rtf
               //richTextBox.SelectedRtf = @"{\rtf1\ansi\b " + richTextBox.SelectedText + "}";              

               
                    

                //convert the StringBuilder source to a string
                String sourceToString = this.source.ToString();

                //set the htmlSource text to contain the StringBuilder source String
                htmlSource.Text = sourceToString;
                    
                
            }//end if else




        }//end method
        /*
         * This method makes a rich text box selection italic if it is not already italic
         * 
         * 
         */
        public void setItalic(RichTextBox richTextBox,TextBox htmlSource)
        {//begin method

            //if the selection is italic
            if (richTextBox.SelectionFont.Italic)
            {//begin if then else

                //remove italic formatting from the selected text
                richTextBox.SelectionFont = new Font(richTextBox.SelectionFont, richTextBox.SelectionFont.Style ^ FontStyle.Italic);
                               

            }
            else
            {
                
                //make the selection italic
                richTextBox.SelectionFont = new Font(richTextBox.SelectionFont, richTextBox.SelectionFont.Style | FontStyle.Italic);
                

                }



        }//end method


        /*
         * This method returns the string between two specified strings
         * 
         * An example would be returning the file between the open and closing body 
         * tags <body> and </body> 
         */
        
                 
        public string GetStringBetweenTags(string value,string startTag,string endTag)
        {
            

            
            //if the value string contains the startTag and the endTag
            if (value.Contains(startTag) && (value.Contains(endTag)))
            {//begin if then else

                //add the index value of the startTag String to the length of the startTag
                int index = value.IndexOf(startTag) + startTag.Length;

                //return the string between startTag and the endTag(or optional end tag2)
                return value.Substring(index, (value.IndexOf(endTag) - index));
            }
            else
            {

                return null;
            }//end if then else

        }//end method


        

        /*
         * This method will return the contents of a file as a String line by line
         * 
         */

         public String readFile(string file)
        {
            //string builder object to hold each line in the file
            StringBuilder lines = new StringBuilder();

            
                //create a streamReader to open a file and read each line
                StreamReader sr = new StreamReader(file);
            
                
            


                //string to hold the line value
                String line;

                // Read lines from the file until the end of 
                // the file is reached.
                while ((line = sr.ReadLine()) != null)
                {//begin while loop

                    //add each line to the string builder object readFile
                    lines.AppendLine(line);

                }//end while loop                
            
            //return the file as a string line by line
            return lines.ToString();

        }//end method

        

        /**
         *    UNDER CONSTRUCTION
         * this method will display a GUI to allow opening of an html file.
         * returns the location of the file to open
         * 
         */
        public void openFileGUI(){//begin method

             //set the document path storing it as a string
            string docPath = Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments);

            
                        
            //set the title of the window
            openFileDialog.Title = "open existing html file";

            //set the file filter for the openFileDialog box
            openFileDialog.Filter = "(*.html)|*.html";

            //set the file FilterIndex to 0
            openFileDialog.FilterIndex = 0;

            //set RestoreDirectory property to true
            openFileDialog.RestoreDirectory = true;

            string test = openFileDialog.SafeFileName;
            Console.WriteLine(test);

            //String to hold file path
            String filePath = docPath + @"\" + openFileDialog.SafeFileName + ".html";

            

            //if the user hits ok for the dialog message prompts
            if (openFileDialog.ShowDialog() == DialogResult.OK && openFileDialog.FileName != null)
            {//begin if then


                //read the file specified 
                //StreamReader readFile = new StreamReader(openFileDialog.FileName);

                //store the contents of the file in the contents String
                //String contents = readFile.ReadToEnd();

                //close the StreamWriter which closes the file
                //readFile.Close();

                //set the FileContents Property to hold the contents of the file opened

                //FileContents = contents;

                //call the readFile method passing the file path as a parameter and storing it in the FileContents Property
                FileContents = this.readFile(filePath);



            }//end if then

        }//end method

        /**
         * This method returns the file name from a string containing
         * the full path name of the file
         * 
         */
        public String safeFileName(String filePath)
        {//begin method

            //create string to hold the file name without the path
            String safeFileName;
            
            //store the file name only extracted from the full file path
            safeFileName = filePath.Substring(filePath.LastIndexOf('\\') + 1);

            //return the file name only
            return safeFileName;

        }//end method


        
   
    }//end class



}//end name space

