﻿using mshtml;
using System;
using System.ComponentModel;
using System.Drawing;
using System.IO;
using System.Net;
using System.Text;
using System.Text.RegularExpressions;
using System.Threading.Tasks;
using System.Windows.Forms;


namespace ViewBuilder
{
    public partial class ViewBuilderMainForm : Form
    {//begin class

        //create a new OpenFileDialog object
        OpenFileDialog openFileDialog = new OpenFileDialog();

        //create a new FileOperations object
        FileOperations fileOperations = new FileOperations();

        //create a new Text object
        Text text = new Text();

        //create an object instance of the static class mshtml.IHTMLDocument2 so its methods can be accessed
        private static mshtml.IHTMLDocument2 doc;

        public static mshtml.IHTMLDocument2 Doc
        {
            get { return ViewBuilderMainForm.doc; }
            set { ViewBuilderMainForm.doc = value; }
        }



        //string to hold the opened file name
        private String openedFileName;

        //string to hold the fileContents
        private String fileContents;

        //String to hold the html of the web browser
        private String temp;

        public String Temp
        {
            get { return temp; }
            set { temp = value; }
        }

        //method to get and set the property of the fileContents String
        public String FileContents
        {
            get { return fileContents; }
            set { fileContents = value; }
        }

        //method to get and set the property of the openFileName String
        public String OpenedFileName
        {
            get { return openedFileName; }
            set { openedFileName = value; }
        }


        
                
        public ViewBuilderMainForm()
        {//begin Constructor
            InitializeComponent();

            
                  
            //place any necessary initialization code here

            

        }//end Constructor

       

        

        private void ViewBuilder_Load(object sender, EventArgs e)
        {//begin method
            
               

         }//end method
           
        private void browserLoad_DocumentCompleted(object sender, WebBrowserDocumentCompletedEventArgs e)
        {
            
            //create a new event handler after the browser document loads
            //this.browser.Document.Click += new System.Windows.Forms.HtmlElementEventHandler(Document_MouseDown);

           

            
     
        }

        private void Document_MouseDown(object sender, HtmlElementEventArgs e)
        {


           // htmlOutput.Text = e.KeyPressedCode.ToString();

            //if (e.KeyPressedCode == 0)
            {



                //htmlOutput.Text = browser.DocumentText;
                //browser.Refresh();

                //browser.DocumentText = "<html><body></body></html>";

               // String text = htmlOutput.Text;

               // String match = "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 Transitional//EN\">";

                //char[] matchCharArray = match.ToCharArray();

               // String filteredText = text.TrimStart(matchCharArray);



                //doc.write(htmlOutput.Text);
                                
                //doc.designMode = "On";

            }

            

        }

        
        private void openFileButton_Click(object sender, EventArgs e)
        {//begin method
                        
            
            //set the document path storing it as a string
            string docPath = Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments);

            //set the initial directory
            openFileDialog.InitialDirectory = docPath;            

            //set the title of the window
            openFileDialog.Title = "open existing html file";

            //set the file filter for the openFileDialog box
            openFileDialog.Filter = "(*.html)|*.html";

            //set the file FilterIndex to 0
            openFileDialog.FilterIndex = 0;

            //set RestoreDirectory property to true
            openFileDialog.RestoreDirectory = true;

            //if the browser document text is equal to an empty html page
            if (browser.DocumentText == "")
            {//begin if then

                //load an file document into the browser so there is no null object expection thrown
                //must be done before the mshtml.IHTMLDocument2 is created
                browser.DocumentText = "<html><body></body></html>";

            }//end if then

            
                           
            
            //if the user hits ok for the dialog message prompts
            if (openFileDialog.ShowDialog() == DialogResult.OK && openFileDialog.FileName != null)
            {//begin if then


               
                                
                //set the value of the msthtml.IHTMLDocument object name doc created to allow access to the 
                //loaded file documents (dom) or document object model.
                Doc = (mshtml.IHTMLDocument2)this.browser.Document.DomDocument;

                

                //set the design mode to on this must be done to allow typing and inserting elements into 
                //the browser effectively turning the browser into an editable document.
                Doc.designMode = "On";

                //String to hold file path
                String filePath = openFileDialog.FileName;


                //select all of the currently opened text displayed in the webpage
                Doc.execCommand("SelectAll");

                //delete the text that was diplayed on the web page
                Doc.execCommand("Delete");

                //refresh the browser so the caret postion moves to the top of the document
                Doc.execCommand("Refresh");

                

               

                //read the file specified 
                StreamReader readFile = new StreamReader(filePath);

                //store the file contents
                FileContents = readFile.ReadToEnd();                

                

                //write the contents of the file to the browser document
                Doc.write(FileContents);              

                

                //set the contents of the htmlOutput to the hold the contents of the Html file loaded
                htmlOutput.Text = FileContents;
                

                //close the StreamWriter which closes the file
                readFile.Close();

                //set the name of the opened file
                OpenedFileName = openFileDialog.SafeFileName;

                //set the fileNameLabel text to the name of the opened file
                fileNameLabel.Text = OpenedFileName;         

                //clear the file name so another file can be opened
                openFileDialog.FileName = null;

                

            }//end if then         
            
            

            
        }//end method

        private void boldTextButton_Click(object sender, EventArgs e)
        {//begin method

            //make the selection bold
            Doc.execCommand("Bold", false, null);

           
        }//end method

        private void italicTextButton_Click(object sender, EventArgs e)
        {//begin method

            //make the selection italic
            Doc.execCommand("Italic", false, null);
            

        }//end method

        
        private void testFunctionButton_Click(object sender, EventArgs e)
        {//begin function

            String html = "<h3>it worked</h3>";


            Clipboard.SetText(html, TextDataFormat.Html);

            
            Doc.execCommand("Paste");

        }//end function
   
        
       

        private void underlineTextButton_Click(object sender, EventArgs e)
        {//begin method

            //underline the text selection
            Doc.execCommand("Underline", false, null);
            
        }//end method

        private void insertParagraphButton_Click(object sender, EventArgs e)
        {//begin method

            //underline the text selection
            Doc.execCommand("InsertParagraph", false, null);

        }//end method

        private void newFileButton_Click(object sender, EventArgs e)
        {//begin method                      
            

            //set the name of the opened file
            String newFile = "NewWebPage.html";

            //set the openedFileName to the value of the newFile string
            OpenedFileName = newFile;


            //set the fileNameLabel text to the name of the opened file
            fileNameLabel.Text = newFile;

            //if the browser document text is equal to an empty html page
            if (browser.DocumentText == "")
            {//begin if then

                //load an file document into the browser so there is no null object expection thrown
                //must be done before the mshtml.IHTMLDocument2 is created
                browser.DocumentText = "<html><body></body></html>";

            }//end if then


            //set the value of the msthtml.IHTMLDocument object name doc created to allow access to the 
            //loaded file documents (dom) or document object model.
            Doc = (mshtml.IHTMLDocument2)this.browser.Document.DomDocument;



            //set the design mode to on this must be done to allow typing and inserting elements into 
            //the browser effectively turning the browser into an editable document.
            Doc.designMode = "On";

            //String to hold file path
            String filePath = newFile;

            //select all of the currently opened text displayed in the webpage
            Doc.execCommand("SelectAll");

            //delete the text that was diplayed on the web page
            Doc.execCommand("Delete");

            //refresh the browser so the caret postion moves to the top of the document
            Doc.execCommand("Refresh");
                        
            //store the file contents
            FileContents = "<html><body></body></html>";

            //write the contents of the file to the browser document
            Doc.write(FileContents);

            //set the contents of the htmlOutput to the hold the contents of the Html file loaded
            htmlOutput.Text = FileContents;
            
        }//end method

        private void saveButton_Click(object sender, EventArgs e)
        {//begin method

            //create a new SaveFileDialog object
            SaveFileDialog saveFileDialog = new SaveFileDialog();

            //set the title of the window
            saveFileDialog.Title = "Save Web Page";            

            //set the name of the file name in the saveFileDialog box to the name of 
            //the currently opened
            saveFileDialog.FileName = OpenedFileName;

            //set the extension of the file to save
            saveFileDialog.Filter = "(*.html)|*.html";

            //set the first extension displayed 
            saveFileDialog.FilterIndex = 0;

            //set the RestoreDirectory property to true
            saveFileDialog.RestoreDirectory = true;
                       

            //if the user hits ok for the dialog message prompts
            if (saveFileDialog.ShowDialog() == DialogResult.OK && saveFileDialog.FileName != null)
            {//begin outer if then

                //String to hold file path
                String path = saveFileDialog.FileName;

                //create StreamWriter object so we save the file
                StreamWriter saveFile = new StreamWriter(path, false);

                
                //write the html of the browser to a file
                saveFile.Write(browser.DocumentText);

                //store the full file path from the saveFileDialog Control
                String filePath = saveFileDialog.FileName;

                //return the file name only from the full path storing it in the safeFileName String
                String safeFileName = fileOperations.safeFileName(filePath);
               
                //set the currently opened file name to the name the file was saved as
                OpenedFileName = safeFileName;

                //set the fileNameLabel text to the name of the opened file
                fileNameLabel.Text = OpenedFileName;       

                //close the StreamWriter which closes the file
                saveFile.Close();

            }//end if then
            
       

        }//end method
                     
        private void browser_PreviewKeyDown(object sender, PreviewKeyDownEventArgs e)
        {//begin method

            
            
        }//end method
        


        private void htmlOutput_TextChanged(object sender, EventArgs e)
        {//begin method

            


                      

        }//end method

        private void ViewBuilderMainForm_KeyDown(object sender, KeyEventArgs e)
        {
            htmlOutput.Text = browser.DocumentText;
        }

        private void htmlOutput_MouseDown(object sender, MouseEventArgs e)
        {//begin method

            //////begin filtering and formatting the html text from the web browser control//////

            //meta tag automatically generated by the web browser control
            String metaTag = "<META name=GENERATOR content=\"MSHTML 9.00.8112.16448\">";

            //filter the metaTag from the html document
            String filteredText = text.filterFirstString(metaTag, browser.DocumentText);

            //set the contents of the htmlOutput textbox to the  filtered html in the browser WebBrowser Control
            Temp = filteredText;


            ///Replace <P> and <P> Tags with <br/> tag
            htmlOutput.Text = text.replaceAll(browser.DocumentText, "</P>", "<br/>");
            htmlOutput.Text = text.replaceAll(htmlOutput.Text, "<P>", "");

            //Replace the <STRONG> and </STRONG> tags with the <b> and </b> tags
            htmlOutput.Text = text.replaceAll(htmlOutput.Text, "<STRONG>", "<b>");
            htmlOutput.Text = text.replaceAll(htmlOutput.Text, "</STRONG>", "</b>");


            //Replace the <EM> and </EM> tags with the <i> and </i> tags
            htmlOutput.Text = text.replaceAll(htmlOutput.Text, "<EM>", "<i>");
            htmlOutput.Text = text.replaceAll(htmlOutput.Text, "</EM>", "</i>");

            


        }

        private void createLinkButton_Click(object sender, EventArgs e)
        {//begin method

            //create a link
            Doc.execCommand("CreateLink");

        }//end method

        private void unlinkButton_Click(object sender, EventArgs e)
        {//begin method

            //create a link
            Doc.execCommand("UnLink");

        }

        private void createTableButton_Click(object sender, EventArgs e)
        {//begin method


            CreateTableForm tableForm = new CreateTableForm();

            tableForm.Show();

            //String html = "<table><tr><td>first coloumn</td><td>second column</td></tr></table>";


            //set the html to insert into the web page
            //Clipboard.SetText(html, TextDataFormat.Html);


            //paste the html into the webpage at the cursor position
            //doc.execCommand("Paste");

            

            

            


        }//end method

        

        
        

        

        
    }//end class
}//end namespace
